#!/usr/bin/env python3

import socket
from base64 import b64decode
from base64 import b64encode

REMOTE_IP = "204.216.217.175"
REMOTE_PORT = 4321

# ------------------------------------------------------

def solve():
    with socket.socket(socket.AF_INET, socket.SOCK_STREAM) as sock:
        sock.connect((REMOTE_IP, REMOTE_PORT))
        
        # ignore initial response
        sock.recv(len(b'Welcome to Many-times pad.\n\n'))

        # get flag
        try:
            sock.recv(len(b'Make a choice:\n [1] Show flag\n [2] Encrypt\n\n'))
            sock.send(b'1')
            s = sock.recv(1024).decode("utf-8")
            b64_flag = s.split("Flag: ")[1]
            flag_bytes = b64decode(b64_flag)
            print(f"Flag_encrypted_bytes = {list(flag_bytes)}")
            
        except Exception as e:
            print("Could not read flag")
            exit()

        # send plaintext to encrypt
        plaintext = b"HELLO"
        try:
            sock.recv(len(b'Make a choice:\n [1] Show flag\n [2] Encrypt\n\n'))
            sock.send(b'2')
            sock.recv(len(b'Send data to encrypt:\n'))

            print(f"Sending plaintext: {list(plaintext)}")
            
            sock.send(b64encode(plaintext))
            s = sock.recv(1024).decode("utf-8")
            encrypted_bytes_b64 = s.split("Encrypted: ")[1]
            encrypted_bytes = b64decode(encrypted_bytes_b64)
            print(f"Received Encrypted: {list(encrypted_bytes)}")
            
        except Exception as e:
            print("Could not send plaintext")
            exit()

if __name__ == "__main__":
    solve()
